/****************************************************************************
* File:         $Workfile$
* Revision:     $Revision: 1.1 $
* Date:         $Date: 2009/03/18 02:59:02 $
*
* Overview:     
* Functions:
*
* Author:       Ian Tsao
* 
* -- Metanoia Copyright Notice --
*
* (C) Copyright 2005 Metanoia, Inc. All rights reserved.
* 
* Metanoia reserves the right to change specifications without notice. 
* Copyright 2005 Metanoia, Inc. All rights reserved. Preliminary Data-Sheet 
* indicates this product is in design and the specification may change. 
* Electrical parametrics have not been analyzed and are not specified. Do not 
* use this data sheet as a design reference document. Please contact Metanoia 
* for a current data sheet that may be used as a design reference. All 
* contents of this document are protected by copyright law and may not be 
* reproduced without the express written consent of Metanoia, Inc. Metanoia, 
* the Metanoia logo, and combinations thereof are trademarks of Metanoia, Inc. 
* Other product names used in this publication are for identification purposes 
* only and may be trademarks or registered trademarks of their respective 
* companies. The contents of this document are provided in connection with 
* Metanoia, Inc. products. Metanoia, Inc. has made best efforts to ensure that 
* the information contained herein is accurate and reliable. However, Metanoia, 
* Inc. makes no warranties, express or implied, as to the accuracy or 
* completeness of the contents of this publication and is providing this 
* publication 'as is'. Metanoia, Inc. reserves the right to make changes to 
* specifications and product descriptions at any time without notice, and to 
* discontinue or make changes to its products at any time without notice. 
* Metanoia, Inc. does not assume any liability arising out of the application 
* or use of any product or circuit, and specifically disclaims any and all 
* liability, including without limitation special, consequential, or 
* incidental damages.
* 
****************************************************************************/
#include "dsll2.h"
/*#include "mttypes.h"
#include "debugp.h"
#include "hdlc.h"
#include "port.h"*/

mt_uint32 ctrl_payload_frame(mt_uint8* ctrlframe, mt_uint8 eocaddr,
			mt_uint8 eocctrl, mt_uint32 frameoffset, 
			mt_uint8* infopayload,mt_uint32 infopayloadlen)
{
	mt_uint16 j,fcs = HDLC_FCS_INIT;
	mt_uint32 ctrlframelen = 0;
	mt_uint32 txbyteindex = frameoffset; 
	mt_uint8  txbyte,i;

	if(infopayloadlen>510)
	{
		PRINTL(DBG_LVL_HDLC,"ctrl_payload_frame: infopayloadlen %i is too big\n", infopayloadlen);
		return 0;
	}
	/*ctrlframe = TxFreeBuf[NumTxFreeBuf++];
	NumTxFreeBuf &= TX_FREE_MAX;*/
	if(hdlc_frame==1)
	{
		ctrlframe[txbyteindex++] = HDLC_LIMITER_FLAG;
		ctrlframelen++;
	}
	ctrlframe[txbyteindex++] = eocaddr;
	fcs = fcs_update(eocaddr,fcs);
	ctrlframe[txbyteindex++] = eocctrl;
	fcs = fcs_update(eocctrl,fcs);
	ctrlframelen +=2;
	j = 0;
	while (infopayloadlen--)
	{
		txbyte = infopayload[j++];
		fcs = fcs_update(txbyte,fcs);

		if(hdlc_frame==1)
		{
			if ( txbyte == 0x7E)
			{
				ctrlframe[txbyteindex++] = 0x7D;
				ctrlframe[txbyteindex++] = 0x5E;
				ctrlframelen +=2;
				if(ctrlframelen>510)
				{
					PRINTL(DBG_LVL_HDLC,"ctrl_payload_frame: infopayloadlen %i is too big\n", infopayloadlen);
					return 0;
				}
			}
			else
			if ( txbyte == 0x7D)
			{
				ctrlframe[txbyteindex++] = 0x7D;
				ctrlframe[txbyteindex++] = 0x5D;
				ctrlframelen +=2;
				if(ctrlframelen>510)
				{
					PRINTL(DBG_LVL_HDLC,"ctrl_payload_frame: infopayloadlen %i is too big\n", infopayloadlen);
					return 0;
				}
			}
			else 
			{
				ctrlframe[txbyteindex++] = txbyte;
				ctrlframelen++;
				if(ctrlframelen>510)
				{
					PRINTL(DBG_LVL_HDLC,"ctrl_payload_frame: infopayloadlen %i is too big\n", infopayloadlen);
					return 0;
				}
			}
		}
		else	//hdlc_frame==0
		{
			ctrlframe[txbyteindex++] = txbyte;
			ctrlframelen++;
			if(ctrlframelen>510)
			{
				PRINTL(DBG_LVL_HDLC,"ctrl_payload_frame: infopayloadlen %i is too big\n", infopayloadlen);
				return 0;
			}
		}
	}

	if(hdlc_frame==1)
	{
		fcs = ~fcs;
		for (i = 0 ; i < 2 ; i ++ ) // octet transparency to be applied to the calculated fcs too. 
		{
			txbyte = fcs & 0x00FF;
			if ( txbyte == 0x7E)
			{
				ctrlframe[txbyteindex++] = 0x7D;
				ctrlframe[txbyteindex++] = 0x5E;
				ctrlframelen +=2;
				if(ctrlframelen>510)
				{
					PRINTL(DBG_LVL_HDLC,"ctrl_payload_frame: infopayloadlen %i is too big\n", infopayloadlen);
					return 0;
				}
			}
			else
			if ( txbyte == 0x7D)
			{
				ctrlframe[txbyteindex++] = 0x7D;
				ctrlframe[txbyteindex++] = 0x5D;
				ctrlframelen +=2;
				if(ctrlframelen>510)
				{
					PRINTL(DBG_LVL_HDLC,"ctrl_payload_frame: infopayloadlen %i is too big\n", infopayloadlen);
					return 0;
				}
			}
			else 
			{
				ctrlframe[txbyteindex++] = txbyte;
				ctrlframelen++;
				if(ctrlframelen>510)
				{
					PRINTL(DBG_LVL_HDLC,"ctrl_payload_frame: infopayloadlen %i is too big\n", infopayloadlen);
					return 0;
				}
			}
			fcs = fcs >> 8;
		}
		ctrlframe[txbyteindex++] = HDLC_LIMITER_FLAG;
		++ctrlframelen;
	}

	if(ctrlframelen>MT_MAX_BUFFERSIZE)
		PRINTL(DBG_LVL_HDLC,"ctrl_payload_frame: infopayloadlen %i is too big\n", infopayloadlen);
	return ctrlframelen;
}

void ctrl_payload_deframe(mt_uint8* rxbuf,mt_uint16 rxlen, port_t *pport)
{
	mt_uint16 rxindex = 0;
	mt_uint8 rxbyte = rxbuf[rxindex];
	mt_uint8* ctrlframe ;
	mt_uint16 ctrlframelen=0;
	mt_uint16 fcscalc=0,i ;
	hdlc_state ctrldeframestate = pport->ctrldeframestate;

	ctrlframe = &pport->buf[0];
	if (ctrldeframestate != HDLC_FRAME_INIT)
	{
		ctrlframe = pport->openctrlframe;
		ctrlframelen = pport->openctrlframelen;
		fcscalc = pport->curfcs;
	}

	if(hdlc_frame==0)
	{
		while (rxindex < rxlen)
		{
			ctrlframe[ctrlframelen++] = rxbyte;
			rxbyte = rxbuf[++rxindex];
		}

		PRINTL(DBG_LVL_HDLC,"HDLC deframe:");
		for(i=0;i<ctrlframelen;i++)
			PRINTL(DBG_LVL_HDLC," %02x", ctrlframe[i]);
		PRINTL(DBG_LVL_HDLC,"\n");
	}
	else	//hdlc_frame==1
	{
		while (rxindex < rxlen)
		{
			switch (ctrldeframestate)
			{
				case HDLC_FRAME_OPEN :
				{
					if ( rxbyte == HDLC_LIMITER_FLAG)
					{
						ctrldeframestate = HDLC_FRAME_END;
					}
					else if ( rxbyte == HDLC_ESCAPE_FLAG )
					{
						ctrldeframestate = HDLC_FRAME_ESC;
						rxbyte = rxbuf[++rxindex];
					}
					else 
					{
						fcscalc = fcs_update(rxbyte,fcscalc);
						ctrlframe[ctrlframelen++] = rxbyte;
						rxbyte = rxbuf[++rxindex];
					}
					break;
				}
				case HDLC_FRAME_INIT:
				{
					if (rxbyte == HDLC_LIMITER_FLAG)
					{
						ctrldeframestate = HDLC_FRAME_OPEN;
						fcscalc = HDLC_FCS_INIT;
						ctrlframelen = 0;
					}
					rxbyte = rxbuf[++rxindex];
							
					break;			 
				}
				case HDLC_FRAME_END:
				{
					if (fcscalc == HDLC_MAGIC_FCS)
					{
						ctrldeframestate  = HDLC_FRAME_INIT;
						// RxCtrlPayload(ctrlframe,ctrlframelen-2,pport);
						PRINTL(DBG_LVL_HDLC,"HDLC deframe:");
						for(i=0;i<ctrlframelen-2;i++)
							PRINTL(DBG_LVL_HDLC," %02x", ctrlframe[i]);
						PRINTL(DBG_LVL_HDLC,"\n");
						rxbyte = rxbuf[++rxindex];
					}
					else 
					{
						ctrldeframestate = HDLC_FRAME_INIT;
						rxbyte = rxbuf[++rxindex];
					}
					break;
				}
				case HDLC_FRAME_ESC:
				{
					PRINTL(DBG_LVL_HDLC,"HDLC_FRAME_ESC\n");
					if (rxbyte == 0x5E)
						rxbyte = 0x7E;
					else if (rxbyte == 0x5D)
						rxbyte = 0x7D;
					else if (rxbyte == 0x7E) // abort frame
					{
						ctrldeframestate = HDLC_FRAME_INIT;
						break;
					}
					ctrldeframestate = HDLC_FRAME_OPEN;
					fcscalc = fcs_update(rxbyte,fcscalc);
					ctrlframe[ctrlframelen++] = rxbyte;
					rxbyte = rxbuf[++rxindex];
					break;
				}
			}
		}
	}

	pport->ctrldeframestate = ctrldeframestate ;
	if (ctrldeframestate != HDLC_FRAME_INIT)
	{
		pport->openctrlframe = ctrlframe ;
		pport->openctrlframelen = ctrlframelen ;
		pport->curfcs = fcscalc;
	}
}
