/****************************************************************************
* File:         $Workfile$
* Revision:     $Revision: 1.1 $
* Date:         $Date: 2009/03/18 02:59:02 $
*
* Overview:     
* Functions:
*
* Author:       Ian Tsao
* 
* -- Metanoia Copyright Notice --
*
* (C) Copyright 2005 Metanoia, Inc. All rights reserved.
* 
* Metanoia reserves the right to change specifications without notice. 
* Copyright 2005 Metanoia, Inc. All rights reserved. Preliminary Data-Sheet 
* indicates this product is in design and the specification may change. 
* Electrical parametrics have not been analyzed and are not specified. Do not 
* use this data sheet as a design reference document. Please contact Metanoia 
* for a current data sheet that may be used as a design reference. All 
* contents of this document are protected by copyright law and may not be 
* reproduced without the express written consent of Metanoia, Inc. Metanoia, 
* the Metanoia logo, and combinations thereof are trademarks of Metanoia, Inc. 
* Other product names used in this publication are for identification purposes 
* only and may be trademarks or registered trademarks of their respective 
* companies. The contents of this document are provided in connection with 
* Metanoia, Inc. products. Metanoia, Inc. has made best efforts to ensure that 
* the information contained herein is accurate and reliable. However, Metanoia, 
* Inc. makes no warranties, express or implied, as to the accuracy or 
* completeness of the contents of this publication and is providing this 
* publication 'as is'. Metanoia, Inc. reserves the right to make changes to 
* specifications and product descriptions at any time without notice, and to 
* discontinue or make changes to its products at any time without notice. 
* Metanoia, Inc. does not assume any liability arising out of the application 
* or use of any product or circuit, and specifically disclaims any and all 
* liability, including without limitation special, consequential, or 
* incidental damages.
* 
****************************************************************************/
#include "dsll2.h"

#define HOST_MSG_ADDR 0x12
#define HOST_MSG_CTRL 0x12
#define READ_WORD_COUNT 1

mt_ret mem_dsp_set (mt_uint32 portid, mt_uint32 address, mt_uint8 memtype, mt_uint8 *pdata)
{
	mt_uint8 cbuf[20];

	cbuf[0] = HOST_MSG_ADDR;
	cbuf[1] = HOST_MSG_CTRL;

	cbuf[3] = 0x0c;

	cbuf[4] = memtype;
	cbuf[5] = (address & 0xff0000) >> 16;
	cbuf[6] = (address & 0x00ff00) >> 8;
	cbuf[7] = address & 0x0000ff;
	cbuf[8] = READ_WORD_COUNT;
	cbuf[9] = pdata[0];
	cbuf[10] = pdata[1];
	cbuf[11] = pdata[2];
	return  send_frame_port(portid, 12, cbuf);
}

mt_ret mem_dsp_get (mt_uint32 portid, mt_uint32 address, mt_uint8 memtype, mt_uint8 *pdata)
{

	mt_ret ret;
	mt_uint8 cbuf[20];

	cbuf[0] = HOST_MSG_ADDR;
	cbuf[1] = HOST_MSG_CTRL;

	cbuf[3] = 0x0b;

	cbuf[4] = memtype;
	cbuf[5] = (address & 0xff0000) >> 16;
	cbuf[6] = (address & 0x00ff00) >> 8;
	cbuf[7] = address & 0x0000ff;
	cbuf[8] = READ_WORD_COUNT;
	ret = send_frame_port(portid, 9, cbuf);

	if( ret != MT_OK ) return ret;

	//while(!port_resp_rdy(portid))
	//	;
	get_port_buffer(portid, pdata);
	
	return MT_OK;
}
